﻿'=============================================================================
' Filename: testHook.exe
'=============================================================================
' Author:   Bruno Manchon
' Author of the dll and exemple code (C#) : Michael Kennedy : http://www.codeproject.com/KB/system/globalsystemhook.aspx
' Revision: 1.00
' Date:   26/02/2009
'=============================================================================
' Compiled using Visual Studio 2008
' Include Files: Kennedy.ManagedHooks.dll, SystemHookCore.dll
'=============================================================================
' Code d'exemple d'utilisation des hook clavier et souris en VB.NET 
'=============================================================================
' Remerciments : tomlev & roaster (sur les forums de developpez.net)
' et bien évidament Michael Kennedy...
'=============================================================================
'On importe la dll Kennedy.ManagedHooks
Imports Kennedy.ManagedHooks

Public Class Form1
    'On cré les hooks souris et clavier
    Dim hook_souris As New MouseHook()
    Dim hook_clavier As New KeyboardHook()


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'On ajoute les écouteurs souris et clavier
        AddHandler hook_souris.MouseEvent, AddressOf hook_souris_MouseEvent
        AddHandler hook_clavier.KeyboardEvent, AddressOf hook_clavier_KeyboardEvent
        'Initialement on ne peut cliquer sur le bouton pour lever les hooks!
        Button2.Enabled = False
    End Sub

    'Quand un événement souris est détecté (on passe par valeur l'événement (mEvent) et la position)
    Private Sub hook_souris_MouseEvent(ByVal mEvent As MouseEvents, ByVal position As System.Drawing.Point)
        'On cré une chaine contenant le type du mouvement + la position de la souris
        Dim msg As String = mEvent.ToString() + " " + position.ToString
        'On ajoute la chaine crée dans le textbox 1
        TextBox1.Text = TextBox1.Text + vbCrLf + msg
    End Sub

    'Quand un événement clavier est détecté (on passe par valeur l'événement (mEvent) et la touche)
    Private Sub hook_clavier_KeyboardEvent(ByVal kEvent As KeyboardEvents, ByVal key As Keys)
        'On cré une chaine contenant la touche appuyée + l'action effectuée (down/up)
        Dim msg As String = "Touche " + key.ToString + " " + kEvent.ToString()
        'On ajoute la chaine crée dans le textbox 2
        TextBox2.Text = TextBox2.Text + vbCrLf + msg
    End Sub

    'Quand on clique sur Installer les hooks
    Public Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'On pose les deux hooks
        hook_souris.InstallHook()
        hook_clavier.InstallHook()
        'On affiche initialement du texte pour défférencier les textbox
        TextBox1.Text = "Mouse Event Here"
        TextBox2.Text = "Keyboard Event Here"
        'On désactive le bouton installhook
        Button1.Enabled = False
        'On active le bouton enléve hook
        Button2.Enabled = True
        'On désactive le bouton quitter : il faut lever les hook en premier!
        Button3.Enabled = False
    End Sub
    'Quand on clique sur Désinstaller les hooks
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'On enléve les hooks
        hook_souris.UninstallHook()
        hook_clavier.UninstallHook()
        'On réactive le bouton install hook
        Button1.Enabled = True
        'On désactive le bouton lever les hook
        Button2.Enabled = False
        'On réactive le bouton quitter
        Button3.Enabled = True
    End Sub

    'Bouton quitter
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        End
    End Sub
End Class
